%define name pydio
%define version 5.2.4
%define release 1.beta0
%define httpuser apache
%define ckversion 4.4.5

%if 0%{?fedora} >= 11 || 0%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: Rich-client browser for managing files on a web server
Name: %{name}
Version: %{version}
Release: %{release}%{?dist}
License: AGPLv3
URL: http://pyd.io
Group: Applications/Internet
Source: http://sourceforge.net/projects/ajaxplorer/files/pydio/stable-channel/%{version}/%{name}-core-%{version}.tar.gz
Source1: httpd.conf
Source2: ckeditor_%{ckversion}_standard.zip
Patch0: pydio-5.2.0-rpm_paths.patch
Patch1: pydio-5.2.0-unoconv_no_tmp_home.patch
Patch2: pydio-5.2.0-disconnect_on_session_mismatch.patch
Patch3: pydio-5.2.0-fix_php_path_in_shebang.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}

Requires: php >= 5.3
Requires: php-process
Requires: httpd
Requires: ImageMagick
Requires: ghostscript
Requires: ghostscript-fonts
%if %{useselinux}
Requires: %{_sbindir}/semanage
%endif

Obsoletes: ajaxplorer <= 5.0.3
Provides: ajaxplorer = %{version}

%description
Pydio (formerly AjaXplorer) is a PHP rich-client
browser for managing files on a web server without FTP.
Implements usual file actions, online zip browsing,
text files edition and images preview. Users management
system and multi-languages.


%prep
%setup -q -n %{name}-core-%{version}
%{__unzip} %{SOURCE2} -d plugins/editor.ckeditor
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
# empty build

%install
%{__rm} -rf %{buildroot}
%{__mkdir} -p %{buildroot}/%{_datadir}/%{name}

%{__cp} -pr ./* %{buildroot}/%{_datadir}/%{name}/
%{__mkdir_p} %{buildroot}/%{_localstatedir}/lib/
%{__mv} %{buildroot}/%{_datadir}/%{name}/data %{buildroot}/%{_localstatedir}/lib/%{name}/
# boot.conf should exists
%{__mkdir_p} %{buildroot}/%{_localstatedir}/lib/%{name}/plugins/boot.conf/
# Doc will go in %doc dir
%{__mv} %{buildroot}/%{_datadir}/%{name}/core/doc ./doc
# But CREDITS needs to be accessible
%{__mkdir_p} %{buildroot}/%{_datadir}/%{name}/core/doc
%{__mv} ./doc/CREDITS.txt %{buildroot}/%{_datadir}/%{name}/core/doc

# Move  conf
%{__mkdir_p} %{buildroot}/%{_sysconfdir}/
%{__mv} %{buildroot}/%{_datadir}/%{name}/conf %{buildroot}/%{_sysconfdir}/%{name}
%{__rm} -f %{buildroot}/%{_sysconfdir}/%{name}/{.htaccess,index.html}
%{__mv} %{buildroot}/%{_sysconfdir}/%{name}/RELEASE_NOTE ./

# Create cache dir
%{__mkdir_p} %{buildroot}/%{_localstatedir}/cache/
%{__mv} %{buildroot}/%{_localstatedir}/lib/%{name}/cache %{buildroot}/%{_localstatedir}/cache/%{name}
%{__rm} -f %{buildroot}/%{_localstatedir}/cache/%{name}/{.htaccess,index.html}

# Log dir
%{__mkdir_p} %{buildroot}/%{_localstatedir}/log
%{__mv} %{buildroot}/%{_localstatedir}/lib/%{name}/logs %{buildroot}/%{_localstatedir}/log/%{name}
%{__rm} -f %{buildroot}/%{_localstatedir}/log/%{name}/{.htaccess,index.html}


# Install apache conf
%{__mkdir} -p %{buildroot}/%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0640 %{SOURCE1} %{buildroot}/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%{__mkdir} -p %{buildroot}/%{_localstatedir}/log/%{name}

%clean
rm -rf %{buildroot}

%post
%if %{useselinux}
(
# New File context
# keep httpd_sys_script_rw_t (httpd_var_lib_t prevent dir creation)
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/log/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_datadir}/%{name}/server(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_sysconfdir}/%{name}(/.*)?"
semanage fcontext -a -s system_u -t httpd_var_lib_t -r s0 "%{_localstatedir}/cache/%{name}(/.*)?"
# files created by app
restorecon -R %{_sysconfdir}/%{name}
restorecon -R %{_localstatedir}/lib/%{name}
restorecon -R %{_datadir}/%{name}/server
restorecon -R %{_localstatedir}/log/%{name}
restorecon -R %{_sysconfdir}/%{name}
restorecon -R %{_localstatedir}/cache/%{name}
) &>/dev/null || :
%endif

# Move repo and users file to new location
if [ $1 == 2 ]; then
  if [ -e %{_sysconfdir}/%{name}/repo.ser ]; then
    %{__mv} %{_sysconfdir}/%{name}/repo.ser %{_localstatedir}/lib/%{name}/plugins/conf.serial/repo.ser
  fi
  if [[ ( -d %{_sysconfdir}/%{name}/users && ! -e %{_localstatedir}/lib/%{name}/plugins/auth.serial/users.ser ) ]]; then
    %{__mv} %{_sysconfdir}/%{name}/users/* %{_localstatedir}/lib/%{name}/plugins/auth.serial/
    rmdir %{_sysconfdir}/%{name}/users/
  fi
  # Flush cache
  %{__rm} -f %{_localstatedir}/cache/%{name}/plugins_*.ser
  %{__rm} -f %{_localstatedir}/cache/%{name}/i18n/*.ser
fi

# Migrate ajaxplorer data
if [ -d %{_localstatedir}/cache/ajaxplorer ]; then
    cp -af %{_localstatedir}/cache/ajaxplorer/* %{_localstatedir}/cache/%{name}/ && \
    rm -rf %{_localstatedir}/cache/ajaxplorer
fi
if [ -d %{_localstatedir}/lib/ajaxplorer ]; then
    cp -af %{_localstatedir}/lib/ajaxplorer/* %{_localstatedir}/lib/%{name}/ && \
    rm -rf %{_localstatedir}/lib/ajaxplorer
fi
if [ -d %{_localstatedir}/log/ajaxplorer ]; then
    cp -af %{_localstatedir}/log/ajaxplorer/* %{_localstatedir}/log/%{name}/ && \
    rm -rf %{_localstatedir}/log/ajaxplorer
fi
if [ -d %{_sysconfdir}/ajaxplorer ]; then
    if [ -f %{_sysconfdir}/ajaxplorer/bootstrap_context.php ]; then
        mv -f %{_sysconfdir}/ajaxplorer/bootstrap_context.php %{_sysconfdir}/%{name}/bootstrap_context.php.ajaxplorer
    fi
    cp -af %{_sysconfdir}/ajaxplorer/* %{_sysconfdir}/%{name}/ && \
    rm -rf  %{_sysconfdir}/ajaxplorer
fi

%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/log/%{name}(/.*)?"
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    semanage fcontext -d "%{_datadir}/%{name}/server(/.*)?"
    semanage fcontext -d "%{_sysconfdir}/%{name}(/.*)?"
    semanage fcontext -d "%{_localstatedir}/cache/%{name}(/.*)?"
    ) &>/dev/null || :
fi
%endif


%files
%defattr(-,root,root)
%doc RELEASE_NOTE
%doc %dir doc
%{_datadir}/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/*
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/lib/%{name}/plugins/*
%{_localstatedir}/lib/%{name}/*
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/log/%{name}
%dir %attr(770,root,%{httpuser}) %{_localstatedir}/cache/%{name}
%dir %attr(770,root,%{httpuser}) %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%config(noreplace) %attr(660,root,%{httpuser}) %{_sysconfdir}/%{name}/*

%changelog
* Mon Oct 20 2014 Daniel B. <daniel@firewall-services.com> 5.2.4-1
- Upgrade to 5.2.4
- Upgrade ckeditor to 4.4.5

* Thu Mar 20 2014 Daniel B. <daniel@firewall-services.com> 5.2.3-1
- Upgrade to 5.2.3
- Upgrade ckeditor to 4.3.3

* Mon Feb 24 2014 Daniel B. <daniel@firewall-services.com> 5.2.2-1
- Upgrade to 5.2.2
- Remove now unused conf.editor.imagick.inc conf file

* Fri Feb 7 2014 Daniel B. <daniel@firewall-services.com> 5.2.1-1
- Upgrade to 5.2.1

* Tue Jan 21 2014 Daniel B. <daniel@firewall-services.com> 5.2.0-1
- Upgrade to 5.2.0
- Upgrade ckeditor to 4.3.2

* Thu Jan 9 2014 Daniel B. <daniel@firewall-services.com> 5.0.4-6
- Rise lucene time limit to 300 sec per doc (needed for some huge PDF)

* Tue Dec 3 2013 Daniel B. <daniel@firewall-services.com> 5.0.4-5
- Use HTML links in mail invitation sent from the share center

* Mon Nov 18 2013 Daniel B. <daniel@firewall-services.com> 5.0.4-4
- Remove the locales cache on upgrade

* Fri Nov 15 2013 Daniel B. <daniel@firewall-services.com> 5.0.4-3
- Fix php path in sheband of some scripts

* Fri Nov 15 2013 Daniel B. <daniel@firewall-services.com> 5.0.4-2
- Spec file cleanup
- Switch to tar.gz to get smaller SRPM

* Thu Oct 17 2013 Daniel B. <daniel@firewall-services.com> 5.0.4-1
- Rename to pydio
- upgrade to 5.0.4
- Migrate ajaxplorer data to pydio directories
- Create the boot.conf directory
- make the htaccess in the public folder writeable by apache

* Tue Oct 8 2013 Daniel B. <daniel@firewall-services.com> 5.0.3-2
- Drop a few patches which just enabled some plugins
- Upgrade ckeditor to 4.2.1
- Rebase disconnect_on_session_mismatch patch

* Tue Sep 10 2013 Daniel B. <daniel@firewall-services.com> 5.0.3-1
- upgrade to AjaXplorer 5.0.3
- upgrade ckeditor to 4.2

* Fri Jul 19 2013 Daniel B. <daniel@firewall-services.com> 5.0.2-1
- upgrade to AjaXplorer 5.0.2

* Mon Jul 1 2013 Daniel B. <daniel@firewall-services.com> 5.0.1-1
- upgrade to AjaXplorer 5.0.1

* Mon Jun 3 2013 Daniel B. <daniel@firewall-services.com> 5.0.0-1
- upgrade to AjaXplorer 5.0.0

* Tue May 14 2013 Daniel B. <daniel@firewall-services.com> 4.3.4-1
- upgrade to Ajaxplorer 4.3.4

* Sat May 4 2013 Daniel B. <daniel@firewall-services.com> 4.3.3-1
- upgrade to Ajaxplorer 4.3.3 (v5 final RC)
- upgrade ckeditor to 4.1.1
- requires php 5.3

* Thu Jan 17 2013 Daniel B. <daniel@firewall-services.com> 4.2.3-2
- fix isWriteable patch
- Rebase enable_imagick patch
- upgrade ckeditor to 4.0.1
- Disconnect user if http session doesn't match ajxp's one

* Mon Nov 12 2012 Daniel B. <daniel@firewall-services.com> 4.2.3-1
- upgrade to 4.2.3
- upgrade ckeditor to 3.6.5

* Mon Jul 23 2012 Daniel B. <daniel@firewall-services.com> 4.2.2-1
- upgrade to 4.2.2

* Mon Jun 25 2012 Daniel B. <daniel@firewall-services.com> 4.2.0-1
- upgrade Ajaxplorer to 4.2.0
- upgrade ckeditor to 3.6.3

* Fri Mar 02 2012 Daniel B. <daniel@firewall-services.com> 4.0.4-8
- upgrade to 4.0.4 (security fix)

* Fri Feb 17 2012 Daniel B. <daniel@firewall-services.com> 4.0.3-8
- upgrade to 4.0.3

* Mon Jan 02 2012 Daniel B. <daniel@firewall-services.com> 4.0.1-8
- upgrade to 4.0.1

* Thu Dec 08 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-7
- Add support for office files preview in editor.imagick
- Disable Fileinfo mime type detection in editor.browser as it's
  unreliable (especially with MS Office files)

* Mon Nov 28 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-6
- Don't save last directory in pref.ser

* Mon Nov 21 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-5
- Fix compatibility with Firefox 9
- Fix JS bootstrap when opening through a target="_blank" link under Firefox or Opera
- Enable editor.imagick plugin
- Enable and bundle ckeditor
- Make open with the default action
- Add support for LOGOUT_URL in auth.basic_http

* Thu Oct 06 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-4
- Apply a patch to fix a compatibility issue with the html uploader
  under Firefox 7

* Wed Sep 28 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-3
- Don't exit with error if SELinux is disabled

* Mon Jul 04 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-2
- Don't restart apache on install/remove/upgrade

* Fri Jun 24 2011 Daniel B. <daniel@firewall-services.com> 3.2.4-1
- Initiale release

